digiKam Developer Documentation: Digikam::SearchXmlCachingReader Class Reference

| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
Digikam::SearchXmlCachingReader Class Reference
Inheritance diagram for Digikam::SearchXmlCachingReader:

## Public Member Functions
| SearchXmlCachingReader (const QString &xml)
| This class has the same semantics as SearchXmlReader, but performs some caching and is thus much more relaxed than SearchXmlReader about the calling order of methods: With this class, you can access properties of a group until the next group is read, access properties and the value of a field until the next field is read, with all calls possible multiple times.
QString | fieldName () const override
SearchXml::Operator | fieldOperator () const override
| Returns the field attributes.
SearchXml::Relation | fieldRelation () const override
QString | groupCaption () const override
| Returns the (optional) group caption.
SearchXml::Operator | groupOperator () const override
| Returns the group operator.
SearchXml::Element | readNext () override
| Continue parsing the document.
QString | value () override
| Returns the field values.
QDateTime | valueToDateTime () override
QList< QDateTime > | valueToDateTimeList () override
double | valueToDouble () override
QList< double > | valueToDoubleList () override
QList< double > | valueToDoubleOrDoubleList () override
int | valueToInt () override
QList< int > | valueToIntList () override
QList< int > | valueToIntOrIntList () override
qlonglong | valueToLongLong () override
QList< qlonglong > | valueToLongLongList () override
QStringList | valueToStringList () override
QList< QString > | valueToStringOrStringList () override
Public Member Functions inherited from Digikam::SearchXmlReader
| SearchXmlReader (const QString &xml)
SearchXml::Operator | defaultFieldOperator () const
| Returns the default field operator.
bool | isFieldElement () const
| Returns if the current element is a field element (start or end element).
bool | isGroupElement () const
| Returns if the current element is a group element (start or end element).
void | readToEndOfElement ()
| General helper method: Reads XML until the end element of the current start element in reached.
void | readToFirstField ()
| General helper method: Reads XML until the first field of the next or first found group is reached.
bool | readToStartOfElement (const QString &name)
| General helper method: Reads XML a start element with the given name is found.

## Protected Attributes
QString | m_fieldName
SearchXml::Operator | m_fieldOperator = SearchXml::And
SearchXml::Relation | m_fieldRelation = SearchXml::Equal
QString | m_groupCaption
SearchXml::Operator | m_groupOperator = SearchXml::And
bool | m_readValue = false
QVariant | m_value
Protected Attributes inherited from Digikam::SearchXmlReader
SearchXml::Operator | m_defaultFieldOperator

## Additional Inherited Members
Protected Member Functions inherited from Digikam::SearchXmlReader
SearchXml::Operator | readOperator (const QString &, SearchXml::Operator) const
SearchXml::Relation | readRelation (const QString &, SearchXml::Relation) const

## Member Function Documentation

## ◆ fieldName()

QString Digikam::SearchXmlCachingReader::fieldName | ( |  | ) | const
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ fieldOperator()

SearchXml::Operator Digikam::SearchXmlCachingReader::fieldOperator | ( |  | ) | const
| overridevirtual

Only valid if the current element is a field. fieldOperator returns the default operator if the field has not specified any.

Reimplemented from Digikam::SearchXmlReader.

## ◆ fieldRelation()

SearchXml::Relation Digikam::SearchXmlCachingReader::fieldRelation | ( |  | ) | const
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ groupCaption()

QString Digikam::SearchXmlCachingReader::groupCaption | ( |  | ) | const
| overridevirtual

Only valid if the current element is a group.

Reimplemented from Digikam::SearchXmlReader.

## ◆ groupOperator()

SearchXml::Operator Digikam::SearchXmlCachingReader::groupOperator | ( |  | ) | const
| overridevirtual

Only valid if the current element is a group.

Reimplemented from Digikam::SearchXmlReader.

## ◆ readNext()

SearchXml::Element Digikam::SearchXmlCachingReader::readNext | ( |  | ) |
| overridevirtual

Returns the type of the current element.

Reimplemented from Digikam::SearchXmlReader.

## ◆ value()

QString Digikam::SearchXmlCachingReader::value | ( |  | ) |
| overridevirtual

Only valid if the current element is a field. This reads to the end element of the field, and converts the found text/elements to the desired output.

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToDateTime()

QDateTime Digikam::SearchXmlCachingReader::valueToDateTime | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToDateTimeList()

QList< QDateTime > Digikam::SearchXmlCachingReader::valueToDateTimeList | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToDouble()

double Digikam::SearchXmlCachingReader::valueToDouble | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToDoubleList()

QList< double > Digikam::SearchXmlCachingReader::valueToDoubleList | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToDoubleOrDoubleList()

QList< double > Digikam::SearchXmlCachingReader::valueToDoubleOrDoubleList | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToInt()

int Digikam::SearchXmlCachingReader::valueToInt | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToIntList()

QList< int > Digikam::SearchXmlCachingReader::valueToIntList | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToIntOrIntList()

QList< int > Digikam::SearchXmlCachingReader::valueToIntOrIntList | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToLongLong()

qlonglong Digikam::SearchXmlCachingReader::valueToLongLong | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToLongLongList()

QList< qlonglong > Digikam::SearchXmlCachingReader::valueToLongLongList | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToStringList()

QStringList Digikam::SearchXmlCachingReader::valueToStringList | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.

## ◆ valueToStringOrStringList()

QList< QString > Digikam::SearchXmlCachingReader::valueToStringOrStringList | ( |  | ) |
| overridevirtual

Reimplemented from Digikam::SearchXmlReader.